#!/bin/bash
#exposure_finder.sh


OKITA="okita@192.168.161.90"

#ディレクトリの移動 for sextractor
cd /program/LX200/


#(1)AIRT-Finderによる撮像。露出時間を変えて合計13枚撮像。
rm -rf /program/LX200/exposure_finder/*.fits
rm -rf /program/LX200/command/finder_ccd.sh
printf "#!/bin/bash\n
night_exposure -t 0.001 -s on -b 1 -o /program/LX200/exposure_finder/exposure001.fits\n
night_exposure -t 0.002 -s on -b 1 -o /program/LX200/exposure_finder/exposure002.fits\n
night_exposure -t 0.004 -s on -b 1 -o /program/LX200/exposure_finder/exposure003.fits\n
night_exposure -t 0.008 -s on -b 1 -o /program/LX200/exposure_finder/exposure004.fits\n
night_exposure -t 0.016 -s on -b 1 -o /program/LX200/exposure_finder/exposure005.fits\n
night_exposure -t 0.032 -s on -b 1 -o /program/LX200/exposure_finder/exposure006.fits\n
night_exposure -t 0.064 -s on -b 1 -o /program/LX200/exposure_finder/exposure007.fits\n
night_exposure -t 0.128 -s on -b 1 -o /program/LX200/exposure_finder/exposure008.fits\n
night_exposure -t 0.256 -s on -b 1 -o /program/LX200/exposure_finder/exposure009.fits\n
night_exposure -t 0.512 -s on -b 1 -o /program/LX200/exposure_finder/exposure010.fits\n
night_exposure -t 1.024 -s on -b 1 -o /program/LX200/exposure_finder/exposure011.fits\n
night_exposure -t 2.048 -s on -b 1 -o /program/LX200/exposure_finder/exposure012.fits\n
night_exposure -t 4.096 -s on -b 1 -o /program/LX200/exposure_finder/exposure013.fits\n\n" >> /program/LX200/command/finder_ccd.sh
sh /program/LX200/command/finder_ccd.sh


#(2)sextractorで星の情報を抽出し、awkでmedianFWHMを計算
rm -rf /program/LX200/sextractor/image_stat.dat
i=1
while [ $i -le 13 ]
do
    i=`printf "%03d" $i`
    cd /program/LX200/sextractor/
    sex /program/LX200/exposure_finder/exposure$i.fits > /dev/null
    cd /program/LX200/
    awk -f /program/LX200/sextractor/image_stat.awk /program/LX200/sextractor/test.cat >> /program/LX200/sextractor/image_stat.dat
    i=`expr $i + 1`
done
rm -rf /program/LX200/sextractor/test.cat


#(3)awkでサチらない最適な露出時間を計算する
rm -rf /program/LX200/exposure_finder/finder.exposure
awk -f /program/LX200/exposure_finder/best_exposure.awk /program/LX200/sextractor/image_stat.dat > /program/LX200/exposure_finder/finder.exposure
scp -rp /program/LX200/exposure_finder/finder.exposure $OKITA:/program/LX200/exposure_finder/.


#(3)'gnuplotによる表示(省略可)
rm -rf /program/LX200/exposure_finder/best_exposure.plt
awk -f /program/LX200/exposure_finder/best_exposure_gnuplot.awk /program/LX200/sextractor/image_stat.dat > /program/LX200/exposure_finder/best_exposure.plt
gnuplot /program/LX200/exposure_finder/best_exposure.plt


#(4)もし露出時間がうまく決定できない時(best_exposure.awkよりこの時の露出時間は1秒となる)はexposure faultと表示して終了。
#   戻り値は1。
#   (ちなみにtestコマンドだと整数しか比較できないらしいので、1000倍して整数にして比較している)
hoge=`awk '{print $1}' /program/LX200/exposure_finder/finder.exposure`
exposure=`echo "$hoge * 1000 / 1" | bc`
if test $exposure -eq 1000
then
    echo "EXPOSURE FINDER FAULT"
    exit 1
else
    :
fi


#(6)best exposureの画像を撮像
rm -rf /program/LX200/exposure_finder/best_exposure.finder.fits
rm -rf /program/LX200/command/finder_ccd.sh
printf "#!/bin/bash\n
night_exposure -t $hoge -s on -b 1 -o /program/LX200/exposure_finder/best_exposure.finder.fits\n" >> /program/LX200/command/finder_ccd.sh
sh /program/LX200/command/finder_ccd.sh


#露出時間がうまく決定できた時は戻り値0。
echo "EXPOSURE FINDER SUCCESSFUL"
exit 0
