#!/bin/bash
#focus.sh

#Ubuntuのバグ対策。シリアルポートの設定を変更。
stty -F /dev/ttyUSB0 clocal
#ディレクトリの移動 for sextractor
cd /program/LX200/
#フォーカススピードを一番遅く設定
rm -rf /program/LX200/command/lx200.sh
printf "#!/bin/bash\n
/program/LX200/meade :F1# -s 4\n" >> /program/LX200/command/lx200.sh
sh /program/LX200/command/lx200.sh

k=1
while [ $k -le 10 ] #以下の操作を10回実行
do


    #(1)フォーカスを-5secの位置へ移動
    i=1
    while [ $i -le 5 ]
    do
        rm -rf /program/LX200/command/lx200.sh
        printf "#!/bin/bash\n
/program/LX200/meade :F1# -s 4\n
/program/LX200/meade :F+# -s 4\n
sleep 1\n
/program/LX200/meade :FQ# -s 4\n" >> /program/LX200/command/lx200.sh
        sh /program/LX200/command/lx200.sh
        i=`expr $i + 1`
    done


    #(2)0.1secで撮像 --> フォーカス移動(+1secの位置)を11回繰り返す
    rm -rf /program/LX200/focus/*.fits
    i=1
    while [ $i -le 11 ]
    do
        i=`printf "%03d" $i`
        rm -rf /program/LX200/command/main_ccd.sh
        printf "#!/bin/bash\n
night_exposure -t 0.1 -s on -b 1 -o /program/LX200/focus/focus$i.fits\n" >> /program/LX200/command/main_ccd.sh
	sh /program/LX200/command/main_ccd.sh

        rm -rf /program/LX200/command/lx200.sh
        printf "#!/bin/bash\n
/program/LX200/meade :F1# -s 4\n
/program/LX200/meade :F-# -s 4\n
sleep 1\n
/program/LX200/meade :FQ# -s 4\n" >> /program/LX200/command/lx200.sh
        sh /program/LX200/command/lx200.sh

        i=`expr $i + 1`
    done


    #(3)フォーカスを元々の位置へ戻す
    i=1
    while [ $i -le 6 ]
    do
        rm -rf /program/LX200/command/lx200.sh
        printf "#!/bin/bash\n
/program/LX200/meade :F1# -s 4\n
/program/LX200/meade :F+# -s 4\n
sleep 1\n
/program/LX200/meade :FQ# -s 4\n" >> /program/LX200/command/lx200.sh
        sh /program/LX200/command/lx200.sh
        i=`expr $i + 1`
    done


    #(4)sextractorで星の情報を抽出し、awkでmedianFWHMを計算
    rm -rf /program/LX200/sextractor/image_stat.dat
    i=1
    while [ $i -le 11 ]
    do
        i=`printf "%03d" $i`
        cd /program/LX200/sextractor/
        sex /program/LX200/focus/focus$i.fits > /dev/null
        cd /program/LX200/
        awk -f /program/LX200/sextractor/image_stat.awk /program/LX200/sextractor/test.cat >> /program/LX200/sextractor/image_stat.dat
        i=`expr $i + 1`
    done
    rm -rf /program/LX200/sextractor/test.cat


    #(5)awkで最小二乗法でベストフォーカスを計算
    rm -rf /program/LX200/focus/command.focus
    awk -f /program/LX200/focus/best_focus.awk /program/LX200/sextractor/image_stat.dat > /program/LX200/focus/command.focus


    #(5)'gnuplotによる表示(省略可)
    rm -rf /program/LX200/focus/best_focus.plt
    awk -f /program/LX200/focus/best_focus_gnuplot.awk /program/LX200/sextractor/image_stat.dat > /program/LX200/focus/best_focus.plt
    gnuplot /program/LX200/focus/best_focus.plt


    #(6)もしベストフォーカス位置が元々の値と+/-1sec未満の場合は既に合焦しているとみなして終了
    command=`sed '1d' /program/LX200/focus/command.focus`
    if test $command -eq 0
    then
	#(6)'on focusであることを表示しon focus画像を取得
        echo "FOCUS SUCCESSFUL"
	rm -rf /program/LX200/focus/on_focus.fits
        rm -rf /program/LX200/command/main_ccd.sh
        printf "#!/bin/bash\n
night_exposure -t 0.1 -s on -b 1 -o /program/LX200/focus/on_focus.fits\n" >> /program/LX200/command/main_ccd.sh
	sh /program/LX200/command/main_ccd.sh

        exit 0


    else

        #(6)''計算したフォーカス位置へ移動
        i=1
        while [ $i -le $command ]
        do
            rm -rf /program/LX200/command/lx200.sh
            printf "#!/bin/bash\n
/program/LX200/meade :F1# -s 4\n
`sed '2d' /program/LX200/focus/command.focus`\n
sleep 1\n
/program/LX200/meade :FQ# -s 4\n" >> /program/LX200/command/lx200.sh
            sh /program/LX200/command/lx200.sh
            i=`expr $i + 1`
        done
        
    fi


    k=`expr $k + 1`
done

echo "FOCUS FAULT"

exit 1
