# best_focus_gnuplot.awk
# awk -f best_focus_gnuplot.awk image_stat.dat
#
# CALCULATE "BEST FOCUS POSITION"

BEGIN{
    n=0
#フォーカスの開始位置を設定(m=?)
    m=-5
    A1=A2=A3=s4=s2=s0=0.0
}

{
    FWHMmed[n]=$1
    X[n]=m
    n++
#フォーカス移動の刻み幅を設定(m=m+?)
    m=m+1
    N=n
}

END{
    for(i=0; i<N; i++){
        s4=s4+X[i]*X[i]*X[i]*X[i]
        s2=s2+X[i]*X[i]
        s0=N
        A1=A1+X[i]*X[i]*FWHMmed[i]
        A2=A2+X[i]*FWHMmed[i]
        A3=A3+FWHMmed[i]
    }
    
#最小二乗法で求めた2次関数の係数
    a=s0/(s4*s0-s2*s2)*A1-s2/(s4*s0-s2*s2)*A3
    b=1/s2*A2
    c=-s2/(s4*s0-s2*s2)*A1+s4/(s4*s0-s2*s2)*A3
    x=-b/2.0/a

#最小二乗法で求めた1次関数の係数
    d=1/s2*A2
    e=1/s0*A3

#gnuplotに渡すデータの作成
    printf ("set yrange [0:20]\n")
    printf ("a=%f\n", a)
    printf ("b=%f\n", b)
    printf ("c=%f\n", c)
    printf ("d=%f\n", d)
    printf ("e=%f\n", e)
    printf ("f(x)=a*x*x+b*x+c\n")
    printf ("g(x)=d*x+e\n")
    printf ("set label 'best focus = %.2f' at 0,3\n", x)
    printf ("plot '/program/LX200/sextractor/image_stat.dat' using (-5+$0):1 with points pt 7, f(x), g(x)\n")
    printf ("pause -1\n")
}
