#!/bin/bash
#observation_01.sh

echo "start observation_01.sh at `date`"


#(1)主望遠鏡にアイピースを取り付ける
echo "please set the eyepiece to the main telescope ([y]/cancel)"
read yes
if [ "$yes" = "cancel" ]
then
    echo "OBSERVATION 01 CANCELED"
    exit 1
fi


#(2)光学ファインダーと主望遠鏡を平行にする
echo "please set the viewfinder to align with the main telescope ([y]/cancel)"
read yes
if [ "$yes" = "cancel" ]
then
    echo "OBSERVATION 01 CANCELED"
    exit 1
fi


#(3)initialize.sh等
sh /program/LX200/initialize.sh
sleep 420
sh /program/LX200/canopus.sh
sleep 240


#(4)手動で主望遠鏡の視野内に天体を導入
echo "please center the arignment star in your eyepiece ([y]/cancel)"
read yes
if [ "$yes" = "cancel" ]
then
    echo "OBSERVATION 01 CANCELED"
    exit 1
fi


#(6)ST-iを取り付ける
echo "please set the ST-i to the main telescope ([y]/cancel)"
read yes
if [ "$yes" = "cancel" ]
then
    echo "OBSERVATION 01 CANCELED"
    exit 1
fi


#(7)自動でフォーカスを決定してmainとファインダーのアライメントを行う
echo "auto focus, auto exposure, auto align..."

#回転角計算とメインのポインティング(決まるまで繰り返す)
sh /program/LX200/rotation.sh
sh /program/LX200/pointing_main.sh
while [ $? -eq 1 ]
do
    sh /program/LX200/rotation.sh
    sh /program/LX200/pointing_main.sh
done

#ピント合わせ(決まるまで繰り返す)
sh /program/LX200/focus.sh
while [ $? -eq 1 ]
do
    sh /program/LX200/focus.sh
done

#メインの露出時間決定(決まるまで繰り返す)
sh /program/LX200/exposure_main.sh
while [ $? -eq 1 ]
do
    sh /program/LX200/exposure_main.sh
done

#ファインダーの露出時間決定(決まるまで繰り返す)
ssh -X jiro@192.168.161.82 sh /program/LX200/exposure_finder.sh
while [ $? -eq 1 ]
do
    ssh -X jiro@192.168.161.82 sh /program/LX200/exposure_finder.sh
done

#回転角計算とメインのポインティング(決まるまで繰り返す)
sh /program/LX200/rotation.sh
sh /program/LX200/pointing_main.sh
while [ $? -eq 1 ]
do
    sh /program/LX200/rotation.sh
    sh /program/LX200/exposure_main.sh
done

#center.shスクリプトの実行(決まるまで繰り返す)
echo "center.sh"
ssh -X jiro@192.168.161.82 sh /program/LX200/center.sh
while [ $? -eq 1 ]
do
    ssh -X jiro@192.168.161.82 sh /program/LX200/center.sh
done


echo "OBSERVATION 01 SUCCESSFUL"
echo "end observation_01.sh at `date`"

exit 0
