#!/bin/bash
#observation_03.sh

#(0)スクリプト開始、 status.dat 30
rm -rf /program/LX200/status.dat
echo "30" > /program/LX200/status.dat
echo "`date -u +%Y/%m/%d` `date -u +%H:%M:%S` 30" >> /program/LX200/obslog.log


#DIMM観測スクリプト、24*6*15=2160回測定、約12時間
k=1
while [ $k -le 48 ]
do

    j=1
    while [ $j -le 6 ]
    do
        #(1)視野中心に天体を再導入
        #rotation.sh, pointing_main.sh
        sh /program/LX200/rotation.sh
        sh /program/LX200/pointing_main.sh
        exitvalue=$?


        #(2)もしmainの視野内に導入できなければfinder, mainの順に導入を試みる
        #(10回やって決まらなければ status.dat 32 で exit 1, 終了)
        #rotation.sh, pointing_finder.sh, rotation.sh, pointing_main.sh
        l=0
        while [ $exitvalue -eq 1 ]
        do
            sh /program/LX200/rotation.sh
            ssh -X jiro@192.168.161.82 sh /program/LX200/pointing_finder.sh
            sh /program/LX200/rotation.sh
            sh /program/LX200/pointing_main.sh
            exitvalue=$?
            l=`expr $l + 1`
            if [ $l -eq 10 ] 
            then
                rm -rf /program/LX200/status.dat
                echo "32" > /program/LX200/status.dat
                echo "`date -u +%Y/%m/%d` `date -u +%H:%M:%S` 32" >> /program/LX200/obslog.log
                exit 1
            fi
        done


        #(3)DIMM観測、15回連続して実施、status.dat 33
        rm -rf /program/LX200/status.dat
        echo "33" > /program/LX200/status.dat
        echo "`date -u +%Y/%m/%d` `date -u +%H:%M:%S` 33" >> /program/LX200/obslog.log

        i=1
        while [ $i -le 15 ]
        do
            echo "$k/$j/$i th DIMM OBSERVATION"
            sh /program/LX200/dimm.sh
            i=`expr $i + 1`
        done



        #(4)LX200から天体の方位角を取得し、方位角が175以上～185未満の場合このスクリプト終了する、 status.dat 34, exit 2
        rm -rf /program/LX200/azimuth.dat
        rm -rf /program/LX200/command/lx200.sh
        printf "#!/bin/bash\n/program/LX200/meade :GZ# -r 4 | sed -e 's/[^0-9,-]/ /g' | sed -e 's/\xDF/ /g'  >> /program/LX200/azimuth.dat\n" >> /program/LX200/command/lx200.sh
        sh /program/LX200/command/lx200.sh
        AZIMUTH=`awk '{print $1}' /program/LX200/azimuth.dat`
        if [ $AZIMUTH -ge 175 -a $AZIMUTH -le 184 ]
        then
            rm -rf /program/LX200/status.dat
            echo "34" > /program/LX200/status.dat
            echo "`date -u +%Y/%m/%d` `date -u +%H:%M:%S` 34" >> /program/LX200/obslog.log
            exit 2
        fi


    j=`expr $j + 1`
    done



    #(5)DIMM観測90回毎にピントを再調整
    #focus.sh(5回やって決まらなければ status.dat 35 で exit 1, 終了)
    sh /program/LX200/focus.sh
    exitvalue=$?

    l=1
    while [ $exitvalue -eq 1 ]
    do
        sh /program/LX200/focus.sh
        exitvalue=$?
        l=`expr $l + 1`
        if [ $l -eq 5 ]; then
            rm -rf /program/LX200/status.dat
            echo "35" > /program/LX200/status.dat
            echo "`date -u +%Y/%m/%d` `date -u +%H:%M:%S` 35" >> /program/LX200/obslog.log
            exit 1
        fi
    done


k=`expr $k + 1`

done



#(5)スクリプトの正常な終了、status.dat 36
rm -rf /program/LX200/status.dat
echo "36" > /program/LX200/status.dat
echo "`date -u +%Y/%m/%d` `date -u +%H:%M:%S` 36" >> /program/LX200/obslog.log

exit 0






