# command_pointing.awk
# awk -f command_pointing.awk -v angle=$rotation tmp2.pointing > command.pointing

BEGIN{
    pixelsize=20.4 #arcsec/pixel for f.l.75mm
    movespeed=120.0  #arcsec/sec  <-- 8x siderial
}

{
    if($3!=0 && $4!=0){
        dX=($3-$1)*pixelsize/movespeed
        dY=($4-$2)*pixelsize/movespeed

        dRa=cos(angle)*dX-sin(angle)*dY	#Ra方向の移動量に変換
        dDec=sin(angle)*dX+cos(angle)*dY    #Dec方向の移動量に変換

        printf "#!/bin/bash\n" 
        if(dRa>=0) printf("/program/LX200/meade :RC# -s 4\n/program/LX200/meade :Mw# -s 4\nsleep %.2f\n/program/LX200/meade :Qw# -s 4\n", dRa)
        else      printf("/program/LX200/meade :RC# -s 4\n/program/LX200/meade :Me# -s 4\nsleep %.2f\n/program/LX200/meade :Qe# -s 4\n", -dRa)
        if(dDec>=0) printf("/program/LX200/meade :RC# -s 4\n/program/LX200/meade :Ms# -s 4\nsleep %.2f\n/program/LX200/meade :Qs# -s 4\n", dDec)
        else      printf("/program/LX200/meade :RC# -s 4\n/program/LX200/meade :Mn# -s 4\nsleep %.2f\n/program/LX200/meade :Qn# -s 4\n", -dDec)
    }
}
