#!/bin/bash
#rotation.sh


JIRO="jiro@192.168.161.82"

#Ubuntuのバグ対策。シリアルポートの設定を変更。
stty -F /dev/ttyUSB0 clocal
#ディレクトリの移動  (ちなみに移動しなくても動くはず)
cd /program/LX200/


#(1)LX200から観測値の経度、緯度、天体の赤経、赤緯、恒星時を取得
#ちなみにASCII 223（°）がコマンドに含まれる場合は、16進数表記 \xDF を用いて削除する
rm -rf /program/LX200/rotation/rotation.dat
rm -rf /program/LX200/command/lx200.sh
printf "#!/bin/bash\n
/program/LX200/meade :Gg# -r 4 | sed -e 's/[^0-9,-]/ /g' | sed -e 's/\xDF/ /g'  >> /program/LX200/rotation/rotation.dat\n
/program/LX200/meade :Gt# -r 4 | sed -e 's/[^0-9,-]/ /g' | sed -e 's/\xDF/ /g'  >> /program/LX200/rotation/rotation.dat\n
/program/LX200/meade :GR# -r 4 | sed -e 's/[^0-9,-]/ /g' | sed -e 's/\xDF/ /g'  >> /program/LX200/rotation/rotation.dat\n
/program/LX200/meade :GD# -r 4 | sed -e 's/[^0-9,-]/ /g' | sed -e 's/\xDF/ /g'  >> /program/LX200/rotation/rotation.dat\n
/program/LX200/meade :GS# -r 4 | sed -e 's/[^0-9,-]/ /g' | sed -e 's/\xDF/ /g'  >> /program/LX200/rotation/rotation.dat\n" >> /program/LX200/command/lx200.sh
sh /program/LX200/command/lx200.sh

#(2)視野の回転角をcで計算して保存
rm -rf /program/LX200/rotation/rotation.angle
/program/LX200/rotation/rotation > /program/LX200/rotation/rotation.angle
scp -rp /program/LX200/rotation/rotation.angle $JIRO:/program/LX200/rotation/.


#ちなみに南天で使用する場合はもしかしたらthetaではなく-thetaとなるかもしれない
#天頂方向と天の北極方向のベクトルのなす角をthetaとしているため、天頂と天の南極なら-thetaとなる可能性がある
#2012/4/23現在、南天の場合は考慮していない

echo "ROTATION ANGLE SUCCESSFUL"
exit 0
