/* rotation.c */
/* gcc -lm -o rotation rotation.c */
/* 時角ha、赤緯de、観測地の緯度laから、視野の回転角thetaを計算する */
/* 視野の回転角thetaは天頂方向と天の北極のなす角と定義する */
/* ちなみに南半球の場合、天頂方向と天の南極のなす角は-thetaとなる?? */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#define PI 3.141592

int main(void)
{
	int i, a, b, c;
	double tmp[5],lo,la,ra,de,st,ha,theta;


	/* 観測地の経度lo、緯度la、天体の赤経ra、赤緯de、グリニッジ恒星時ssを */
	/* /program/LX200/rotation/rotation.datから取り込む*/
	FILE *fi;
	fi = fopen("/program/LX200/rotation/rotation.dat","r");

	for(i=0;i<5;i++){
		fscanf(fi, "%d %d %d\n",&a, &b, &c);
		if(a>0){
			tmp[i]=a+b/60.0+c/3600.0;
		}
		else{
			tmp[i]=a-b/60.0-c/3600.0;
		}
	}

	fclose(fi);
	
	lo=tmp[0]/180.0*PI;
	la=tmp[1]/180.0*PI;
	ra=tmp[2]*15/180.0*PI;
	de=tmp[3]/180.0*PI;
	st=tmp[4]*15/180.0*PI;


	/* 時角haの計算 */
	ha=st-ra;


	/* 視野回転の計算 */
	theta=atan2(cos(la)*sin(ha), (sin(la)*cos(de)-cos(la)*sin(de)*cos(ha)));
	
	printf("%lf\n",theta);

}
